package ClienteServidor;

import java.io.IOException;
import java.net.DatagramPacket;
import java.net.SocketException;

import Dados.*;
import Pacotes.PacoteAck;
import Pacotes.PacoteDados;

public class Servidor {

	static public void main(String args[]) throws Exception{

		DadosServidor.inicializar(); // inicializa dados do servidor

		while (true) {

			DatagramPacket pacoteRecebido = new DatagramPacket(new byte[PacoteDados.tamanhoPacoteDados],PacoteDados.tamanhoPacoteDados);

			try {
				DadosServidor.socket.receive(pacoteRecebido); //espera pacote de dados
			}catch (IOException e) { 
				DadosServidor.socket.close();
				System.out.println("Conexo encerrada");
				System.exit(0);
				break;
			}
			
			PacoteDados pacote = new PacoteDados(pacoteRecebido.getData(), pacoteRecebido.getLength());
		
			int num = pacote.getNumSeq();

			if(num != -1) DadosServidor.totalPacotes = pacote.getTotalPacotes(); // o pacote fim no possui a informao totalPacotes

			if (num >= DadosServidor.base && !DadosServidor.buffer.containsKey(num)) { // pe pacotes no buffer, incrementando pacotesRecebidos
				DadosServidor.buffer.put(num, pacote.getDados());
				DadosServidor.pacotesRecebidos++;
				int completo = (int)(((double)DadosServidor.pacotesRecebidos/DadosServidor.totalPacotes) * 100); 
				System.out.println(completo + "% completo");
			}

			PacoteAck ack = new PacoteAck(num);
			byte[] ackCompleto = ack.montarPacote();
			DatagramPacket enviarAck = new DatagramPacket(ackCompleto, ackCompleto.length, pacoteRecebido.getAddress(), pacoteRecebido.getPort());

			try {
				DadosServidor.socket.send(enviarAck);
				
				if(num == -1){ // caso tenha recebido o pacote fim, enviar 5 acks para diminuir as chances de perda do mesmo e encerrar execuo 
					
					int i = 4;
					while(i > 0){
						Thread.sleep(DadosCliente.timeoutPacote); // serve para d um intervalo entre os acks enviados
						DadosServidor.socket.send(enviarAck);
						i--;
					}

					DadosServidor.socket.close();
					
					System.out.println("Conexo encerrada");

					break;
				}
			
			} catch (IOException e) {
				e.printStackTrace();
				break;
			}

			byte[] dados;
			while ((dados = DadosServidor.buffer.get(DadosServidor.base)) != null) { // escreve dados recebidos ordenadamente no arquivo
				try {
					DadosServidor.streamDados.write(dados);
					DadosServidor.streamDados.flush();
				} catch (IOException e) {
					e.printStackTrace();
					break;
				}
				DadosServidor.base++;
			}
			
			if(DadosServidor.pacotesRecebidos == DadosServidor.totalPacotes){ // verifica se j recebeu todos os pacotes
				System.out.println();
				System.out.println("Arquivo recebido");
				System.out.println();
				try{
					DadosServidor.socket.setSoTimeout(DadosServidor.timeoutSocket); // modifica o timeout para o socket ficar esperando por um pacote fim
					System.out.println("Encerrando conexo...");
				}catch(SocketException e){
					e.printStackTrace();
				}

			}


		}
	}

}
