package Pacotes;

import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;

public class PacoteAck extends Pacote {
	
	static public int tamanhoPacoteAck = 4;

	public PacoteAck(int numSeq) { // construtor para o remetente dos acks
		super(numSeq);
	}

	public PacoteAck(byte[] pacote){ // construtor para o destinatrio dos acks
		DataInputStream pacoteRecebido = new DataInputStream(new ByteArrayInputStream(pacote));
		try {
			setNumSeq(pacoteRecebido.readInt());
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	public byte[] montarPacote() {
		
		ByteArrayOutputStream ack = new ByteArrayOutputStream(tamanhoPacoteAck);
		DataOutputStream enviarAck = new DataOutputStream(ack);
		
		try {
			enviarAck.writeInt(getNumSeq());
		} catch (IOException e) {
			e.printStackTrace();
		}
	
		return ack.toByteArray();

	}
}
