package Pacotes;

import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;

import Dados.DadosCliente;

public class PacoteDados extends Pacote {
	
	static public int tamanhoPacoteDados = 5120;
	static public int tamanhoDados = tamanhoPacoteDados - 8;
	static public int tamanhoPacoteFim = 4;
	
	private byte[]dados;
	private int totalPacotes; // inteiro que vai informar o nmero de pacotes que sero enviados

	public PacoteDados(byte[]dados, int numSeq, int tamanho) { // construtor para o remetente dos dados
		super(numSeq);
		this.dados = new byte[tamanho];
		this.totalPacotes = DadosCliente.totalPacotes;
		System.arraycopy(dados, 0, this.dados, 0, tamanho);
	}

	public PacoteDados(byte[]pacote, int tamanho) throws IOException{ // construtor para o destinatrio dos dados
		
		DataInputStream pacoteRecebido = new DataInputStream(new ByteArrayInputStream(pacote));
		
		setNumSeq(pacoteRecebido.readInt());
		this.totalPacotes = pacoteRecebido.readInt();
		
		if(getNumSeq() != -1){ // verifica se  o pacote fim, pois ele no possui dados
			this.dados = new byte[tamanho-8];
			pacoteRecebido.read(this.dados, 0, tamanho-8);
		}
	}
	
	public PacoteDados(int numSeq){ // construtor para pacote fim, o qual representa o trmino do envio de dados, representando assim o fim da conexo
		super(numSeq);
		this.totalPacotes = DadosCliente.totalPacotes;
	}

	public byte[] montarPacote() {
		
		ByteArrayOutputStream pacote = new ByteArrayOutputStream(8 + this.dados.length);
		DataOutputStream enviaDados = new DataOutputStream(pacote);

		try {
			enviaDados.writeInt(getNumSeq());
			enviaDados.writeInt(this.totalPacotes);
			enviaDados.write(this.dados);
		} catch (IOException e) {
			e.printStackTrace();
		}

		return pacote.toByteArray();
	}
	
	public byte[] montarPacoteFim() {
		
		ByteArrayOutputStream fim = new ByteArrayOutputStream(tamanhoPacoteFim);
		DataOutputStream enviarFim = new DataOutputStream(fim);
		
		try {
			enviarFim.writeInt(getNumSeq());
		} catch (IOException e) {
			e.printStackTrace();
		}
	
		return fim.toByteArray();

	}

	public byte[] getDados(){
		return this.dados;
	}
	
	public int getTotalPacotes(){
		return this.totalPacotes;
	}


}
