package Threads;

import Pacotes.*;
import Dados.*;

import java.io.IOException;
import java.net.DatagramPacket;
import java.util.TimerTask;

public class EnviarDados implements Runnable { 
	

	public void run() {
		
		while (true) {
			byte[] dados = new byte[PacoteDados.tamanhoDados];
			int bytesLidos = 0;

			try {
				bytesLidos = DadosCliente.streamDados.read(dados); // armazena os bytes do arquivo no array
			} catch (IOException e) {
				e.printStackTrace();
			}

			if(bytesLidos <= 0) break; // sai do lao,ps ler todos os bytes do arquivo
			

			DadosCliente.mutex.lock(); 

			PacoteDados pacote = new PacoteDados(dados, DadosCliente.proxNum, bytesLidos);

			DadosCliente.proxNum++;

			synchronized (DadosCliente.bufferPacotes) { // guarda pacotes no buffer
				DadosCliente.bufferPacotes.put(pacote.getNumSeq(), pacote);
			}

			if (pacote.getNumSeq() < DadosCliente.base + DadosCliente.janela){ // envia pacotes
				this.enviar(pacote);
			}

			DadosCliente.mutex.unlock();
		}
	}
	
	public synchronized void enviar(PacoteDados pacote) {
		
		int num = pacote.getNumSeq();
		byte[] pacoteCompleto;
		
		if(num != -1){ // verifica se  o pacote fim
			pacoteCompleto = pacote.montarPacote();
		}else{
			pacoteCompleto = pacote.montarPacoteFim();
		}
		DatagramPacket enviarPacote = new DatagramPacket(pacoteCompleto, pacoteCompleto.length, DadosCliente.ip, DadosCliente.porta);

		try {
			DadosCliente.socket.send(enviarPacote);
		}
		catch (IOException e) {
			e.printStackTrace();
		}

		DadosCliente.timeoutTimer.schedule(new TimeoutPacote(pacote.getNumSeq()), DadosCliente.timeoutPacote); // contador do timeout dos pacotes
	}

	private class TimeoutPacote extends TimerTask {

		private int numSeq;

		public TimeoutPacote(int seqNum) {
			this.numSeq = seqNum;
		}

		public void run() { // reenvia o pacote caso tenho ocorrido um timeout

			DadosCliente.mutex.lock();

			PacoteDados pacote = DadosCliente.bufferPacotes.get(numSeq);
			if (pacote != null) {
				enviar(pacote);
			}

			DadosCliente.mutex.unlock();
		}

	}

	
}
