package Threads;

import Pacotes.*;
import Dados.*;

import java.io.IOException;
import java.net.DatagramPacket;
import java.net.SocketException;

public class EsperarAcks implements Runnable  {

	private EnviarDados enviar; 
	private int pacotesConfirmados;
	
	public EsperarAcks(EnviarDados enviar){
		this.enviar = enviar;
		this.pacotesConfirmados = 0;
	}

	public void run() {
		
		while (true) {

			DatagramPacket pacoteRecebido = new DatagramPacket(new byte[PacoteAck.tamanhoPacoteAck],PacoteAck.tamanhoPacoteAck);

			try {
				DadosCliente.socket.receive(pacoteRecebido);
			} catch (IOException e) {
				break;
			}
			
			PacoteAck  ack = new PacoteAck(pacoteRecebido.getData());
			
			if(ack.getNumSeq() == -1) {
				break;
			}

			DadosCliente.mutex.lock();

			DadosCliente.bufferAcks.add(ack.getNumSeq());
			PacoteDados novo = DadosCliente.bufferPacotes.remove(ack.getNumSeq());
			
			if(novo != null){ // caso no seja um ack que j foi recebido
				this.pacotesConfirmados++;
				int completo = (int)(((double)this.pacotesConfirmados/DadosCliente.totalPacotes) * 100); 
				System.out.println(completo + "% completo");
			}

			int proxPacote = Math.min(DadosCliente.proxNum, DadosCliente.base + DadosCliente.janela); // verifica o menor nmero dos pacotes que ainda no foram enviados 

			while (DadosCliente.bufferAcks.contains(DadosCliente.base)) { // incrementa a base
				DadosCliente.bufferAcks.remove(DadosCliente.base);
				DadosCliente.base++;
			}

			while (DadosCliente.bufferPacotes.containsKey(proxPacote) && proxPacote < DadosCliente.base + DadosCliente.janela) { // envia os pacotes que esto no buffer
				this.enviar.enviar(DadosCliente.bufferPacotes.get(proxPacote));
				proxPacote++;
			}
			
			if(pacotesConfirmados == DadosCliente.totalPacotes){ // caso em que se deve enviar o pacote fim
				
				System.out.println();
				System.out.println("Arquivo enviado");
				System.out.println();
				
				PacoteDados fim = new PacoteDados(-1);
				this.enviar.enviar(fim);
				try {
					DadosCliente.socket.setSoTimeout(DadosCliente.timeoutSocket); // modifica o timeout para o socket ficar esperando por um ack -1
					System.out.println("Encerrando conexo...");
				} catch (SocketException e) {
					e.printStackTrace();
				}
			}
			DadosCliente.mutex.unlock();

		}
		DadosCliente.socket.close(); // fecha socket do cliente
		System.out.println("Conexo encerrada");
		System.exit(0); // encerra o cliente
	}
}
